Subject: [tig-diagnostics] Uploading icmp aup

From: Melinda Shore <[email-masked]>
Date: Mon, 09 Jul 2012 12:07:24 -0800

I'm in the process of uploading the ICMP AUP draft.  I've spent the
last few days looking at it and thinking "no, that's not right" and
then rewriting portions, it's been a bit of a slog.  I've taken the
liberty of adding your name as co-author, both because you've
said that you'd be interested in helping whip this thing into shape
and because I relied quite a bit on your bibliography.

It is being posted as draft-shore-icmp-aup.  If there's interest we
can discuss it at the opsawg session in Vancouver.

Melinda

---

From: Ronald Bonica <[email-masked]>
Date: Wed, 11 Jul 2012 13:51:36 -0400

Hi Melinda,

I think a better approach might be to define an AUP for ICMP in Section 1. In Section 1.1, demonstrate how all existing ICMP messages conform to that AUP. In Section 2, call out areas in which current practice falls short of the goal state in the AUP and in which future ICMP work is required.

Only in Section 3 should you call out inappropriate uses for ICMP. In Section 3, please avoid specific references to specific proposals. The people who we offend are not likely to be supportive of this draft!

IMHO, the only appropriate use for ICMP are:

1) to inform a datagram's originator that a forwarding plane anomaly has been encountered downstream. By examining the ICMP message, the datagram originator must be able to determine whether the forwarding plane anomaly that cause the ICMP message to be sent also caused the original datagram to be discarded. 
2) to discover on-link routers and hosts

In Section 1.1, it should be pretty easy to assign all existing ICMP messages to one of the two categories listed above. The only difficult case is the ICMP Redirect message. However, you could argue that the redirect message reports a forwarding anomaly in which the originator of the ICMP message forwards a packet through the same interface upon which it was received.

In Section two, you could call out cases in which the ICMP message doesn't make it to the originator of the datagram. For example, if a datagram times out inside a tunnel, the ICMP message is sent to a tunnel endpoint. The endpoint device may or may not relay the message to the datagram originator. You can also call out cases in which the ICMP message makes it to the datagram originator, but contains deceptive or incomplete information (e.g., in the presence of NAT).

In Section 3, you can briefly mention that ICMP should not be used as a routing or network management protocol.

What do you think?

                                  Ron

> -----Original Message-----
> From: [email-masked] [mailto:tig-diagnostics-
> [email-masked]] On Behalf Of Melinda Shore
> Sent: Monday, July 09, 2012 4:07 PM
> To: Carlos Pignataro
> Cc: [email-masked]
> Subject: [tig-diagnostics] Uploading icmp aup
> 
> liberty of adding your name as co-author, both because you've said that
> you'd be interested in helping whip this thing into shape and because I
> relied quite a bit on your bibliography.
> 
> It is being posted as draft-shore-icmp-aup.  If there's interest we can
> discuss it at the opsawg session in Vancouver.
> 
> Melinda
> _______________________________________________
> tig-diagnostics mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/tig-diagnostics

---

From: Melinda Shore <[email-masked]>
Date: Wed, 11 Jul 2012 09:58:50 -0800

On 7/11/12 9:51 AM, Ronald Bonica wrote:
> In Section 3, you can briefly mention that ICMP should not be used as
> a routing or network management protocol.

That mostly sounds reasonable.  This morning it occurred to me that
a better summary might be that ICMP should not be used to install/
configure state in network devices, but that's still pretty fuzzy
around the edges.

Melinda

---

From: Ronald Bonica <[email-masked]>
Date: Wed, 11 Jul 2012 14:05:50 -0400

I think that it is easier to say that ICMP should be used for X and for X only, than to list all of the things that ICMP should *not* be used for.

                                             Ron

P.S. BTW, you may be talking to the wrong person about this. The last time I was asked to formulate an AUP for the Internet, I quoted a highly inappropriate song from the Broadway play, "Avenue Q".

> From: Melinda Shore [mailto:[email-masked]]
> Sent: Wednesday, July 11, 2012 1:59 PM
> To: Ronald Bonica
> Cc: Carlos Pignataro; [email-masked]
> Subject: Re: [tig-diagnostics] Uploading icmp aup
> 
> That mostly sounds reasonable.  This morning it occurred to me that a
> better summary might be that ICMP should not be used to install/

---

From: "Carlos Pignataro (cpignata)" <[email-masked]>
Date: Fri, 13 Jul 2012 04:35:10 +0000

I agree that an approach of defining where ICMP should be used is more straightforward than the converse, and moving specifics to the bottom as examples only -- if needed at all.

The other comment, while I like "AUP", I wonder if Guideline (like in RFC 5405) is less controversial than the "P" word.

Ron, you said:
> In Section 1.1, demonstrate how all existing ICMP messages conform to that AUP. 

What about RPL [RFC6550]?

Thanks!

-- Carlos.

---

From: Ronald Bonica <[email-masked]>
Date: Mon, 16 Jul 2012 10:53:58 -0400

> What about RPL [RFC6550]?

Hmmm.... Maybe that one shouldn't have slipped by?

                Ron